<!DOCTYPE html>
<html>
<head>
  <meta charset="UTF-8">
  <title>Form work1</title>
  <script>
    /*
      Задание:
        Сделать шиблонизатор элемента по:
        Ширине input type=range
        Цвету  input type=color
        Высоте input type=number
        Скругление углов input type=number
        Margin input type=number

      Свойсвта: https://developer.mozilla.org/en-US/docs/Web/CSS/CSS_Properties_Reference

      Бонус:
        + Сделать выборку цвета из рандомных 20 цветов которые выбираются из появившегося блока :
        https://s3.envato.com/files/230412754/screenshots/1.png
        За заготовку для рандома цвета использовать функцию из первых занятий.

    */

      window.addEventListener("load", function () {
        var myWidth = document.getElementById('myWidth');
        myWidth.addEventListener('input', function (event) {
          console.log(event.target.value);
          result.style.width = event.target.value + 'px';
        });

        var myHeight = document.getElementById('myHeight');
        myHeight.addEventListener('input', function (event) {
          console.log(event.target.value);
          result.style.height = event.target.value + 'px';
        })

        var myRound = document.getElementById('myRound');
        myRound.addEventListener('input', function (event) {
          console.log(event.target.value);
          result.style.borderRadius = event.target.value + 'px';
        })

        var myMargin = document.getElementById('myMargin');
        myMargin.addEventListener('input', function (event) {
          console.log(event.target.value);
          result.style.margin = event.target.value + 'px';
        })

        var myColor = document.getElementById('myColor');
        myColor.addEventListener('click', function (event) {
          event.preventDefault();
          var colors = document.getElementById('colors');
          for (var i = 0; i < 20; i++) {
            var colorDiv = document.createElement('div');
            var color = randomColor();
            colorDiv.style.backgroundColor = color;
            colorDiv.style.borderRadius = '25px';
            colorDiv.style.width = '50px';
            colorDiv.style.height = '50px';
            colorDiv.style.margin = '5px';
            colorDiv.style.cssFloat = 'left';
            colorDiv.dataset.color = color;
            colorDiv.addEventListener('click', function (e) {
              console.log(e.target.dataset.color);
              result.style.backgroundColor = e.target.dataset.color;
              myColor.value = e.target.dataset.color;
              colors.innerHTML = '';
            });
            colors.append(colorDiv);
          }
        });
      });

      // Получение рандомного света в HEX
      function randomColor() {
        return "#" + Math.random().toString(16).slice(2, 8);       
      }
    </script>
</head>
<body>
  <div class="Templating">
    <form>
      <input type="range" id="myWidth" min="10" max="500" step="10"/>
      <input type="color" id="myColor" min="10" max="500" step="10"/>
      <input type="range" id="myHeight" min="10" max="500" step="10"/>
      <input type="range" id="myRound" min="1" max="50" step="10"/>
      <input type="range" id="myMargin" min="10" max="500" step="10"/>
    </form>

    <div class="TemplatingResult">
      <div id="result" class="result"></div>
    </div>
  </div>


  <div id="colors">
  </div>



  <style>
    #colors{
      width: 300px;

      display: flex;
      flex-wrap: wrap;
    }
    .result{
      width: 50px;
      background: gray;
      box-sizing: border-box;
      padding: 10px;
    }
    #MyValidateForm{
      width: 350px;
      display: flex;
      flex-direction: column;
    }

    #MyValidateForm input{
      margin-bottom: 10px;
      box-sizing: border-box;
      padding: 10px 20px;
    }
    .circle{
      width: 30px;
      height: 30px;
      background: #eee;
      border-radius: 50%;
    }
  </style>
</body>
</html>
